# coding: utf-8

"""
    API

    Audius V1 API

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501

import warnings
from pydantic import validate_call, Field, StrictFloat, StrictStr, StrictInt
from typing import Any, Dict, List, Optional, Tuple, Union
from typing_extensions import Annotated

from pydantic import Field, StrictInt, StrictStr
from typing import Optional
from typing_extensions import Annotated
from pyaudius.models.undisbursed_challenges import UndisbursedChallenges

from pyaudius.api_client import ApiClient, RequestSerialized
from pyaudius.api_response import ApiResponse
from pyaudius.rest import RESTResponseType


class ChallengesApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client


    @validate_call
    def get_undisbursed_challenges(
        self,
        offset: Annotated[Optional[StrictInt], Field(description="The number of items to skip. Useful for pagination (page number * limit)")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="The number of items to fetch")] = None,
        user_id: Annotated[Optional[StrictStr], Field(description="A User ID to filter the undisbursed challenges to a particular user")] = None,
        completed_blocknumber: Annotated[Optional[StrictInt], Field(description="Starting blocknumber to retrieve completed undisbursed challenges")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> UndisbursedChallenges:
        """get_undisbursed_challenges

        Get all undisbursed challenges

        :param offset: The number of items to skip. Useful for pagination (page number * limit)
        :type offset: int
        :param limit: The number of items to fetch
        :type limit: int
        :param user_id: A User ID to filter the undisbursed challenges to a particular user
        :type user_id: str
        :param completed_blocknumber: Starting blocknumber to retrieve completed undisbursed challenges
        :type completed_blocknumber: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_undisbursed_challenges_serialize(
            offset=offset,
            limit=limit,
            user_id=user_id,
            completed_blocknumber=completed_blocknumber,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UndisbursedChallenges",
            '400': None,
            '500': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data


    @validate_call
    def get_undisbursed_challenges_with_http_info(
        self,
        offset: Annotated[Optional[StrictInt], Field(description="The number of items to skip. Useful for pagination (page number * limit)")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="The number of items to fetch")] = None,
        user_id: Annotated[Optional[StrictStr], Field(description="A User ID to filter the undisbursed challenges to a particular user")] = None,
        completed_blocknumber: Annotated[Optional[StrictInt], Field(description="Starting blocknumber to retrieve completed undisbursed challenges")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[UndisbursedChallenges]:
        """get_undisbursed_challenges

        Get all undisbursed challenges

        :param offset: The number of items to skip. Useful for pagination (page number * limit)
        :type offset: int
        :param limit: The number of items to fetch
        :type limit: int
        :param user_id: A User ID to filter the undisbursed challenges to a particular user
        :type user_id: str
        :param completed_blocknumber: Starting blocknumber to retrieve completed undisbursed challenges
        :type completed_blocknumber: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_undisbursed_challenges_serialize(
            offset=offset,
            limit=limit,
            user_id=user_id,
            completed_blocknumber=completed_blocknumber,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UndisbursedChallenges",
            '400': None,
            '500': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )


    @validate_call
    def get_undisbursed_challenges_without_preload_content(
        self,
        offset: Annotated[Optional[StrictInt], Field(description="The number of items to skip. Useful for pagination (page number * limit)")] = None,
        limit: Annotated[Optional[StrictInt], Field(description="The number of items to fetch")] = None,
        user_id: Annotated[Optional[StrictStr], Field(description="A User ID to filter the undisbursed challenges to a particular user")] = None,
        completed_blocknumber: Annotated[Optional[StrictInt], Field(description="Starting blocknumber to retrieve completed undisbursed challenges")] = None,
        _request_timeout: Union[
            None,
            Annotated[StrictFloat, Field(gt=0)],
            Tuple[
                Annotated[StrictFloat, Field(gt=0)],
                Annotated[StrictFloat, Field(gt=0)]
            ]
        ] = None,
        _request_auth: Optional[Dict[StrictStr, Any]] = None,
        _content_type: Optional[StrictStr] = None,
        _headers: Optional[Dict[StrictStr, Any]] = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """get_undisbursed_challenges

        Get all undisbursed challenges

        :param offset: The number of items to skip. Useful for pagination (page number * limit)
        :type offset: int
        :param limit: The number of items to fetch
        :type limit: int
        :param user_id: A User ID to filter the undisbursed challenges to a particular user
        :type user_id: str
        :param completed_blocknumber: Starting blocknumber to retrieve completed undisbursed challenges
        :type completed_blocknumber: int
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """ # noqa: E501

        _param = self._get_undisbursed_challenges_serialize(
            offset=offset,
            limit=limit,
            user_id=user_id,
            completed_blocknumber=completed_blocknumber,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index
        )

        _response_types_map: Dict[str, Optional[str]] = {
            '200': "UndisbursedChallenges",
            '400': None,
            '500': None,
        }
        response_data = self.api_client.call_api(
            *_param,
            _request_timeout=_request_timeout
        )
        return response_data.response


    def _get_undisbursed_challenges_serialize(
        self,
        offset,
        limit,
        user_id,
        completed_blocknumber,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:

        _host = None

        _collection_formats: Dict[str, str] = {
        }

        _path_params: Dict[str, str] = {}
        _query_params: List[Tuple[str, str]] = []
        _header_params: Dict[str, Optional[str]] = _headers or {}
        _form_params: List[Tuple[str, str]] = []
        _files: Dict[
            str, Union[str, bytes, List[str], List[bytes], List[Tuple[str, bytes]]]
        ] = {}
        _body_params: Optional[bytes] = None

        # process the path parameters
        # process the query parameters
        if offset is not None:
            
            _query_params.append(('offset', offset))
            
        if limit is not None:
            
            _query_params.append(('limit', limit))
            
        if user_id is not None:
            
            _query_params.append(('user_id', user_id))
            
        if completed_blocknumber is not None:
            
            _query_params.append(('completed_blocknumber', completed_blocknumber))
            
        # process the header parameters
        # process the form parameters
        # process the body parameter


        # set the HTTP header `Accept`
        if 'Accept' not in _header_params:
            _header_params['Accept'] = self.api_client.select_header_accept(
                [
                    'application/json'
                ]
            )


        # authentication setting
        _auth_settings: List[str] = [
        ]

        return self.api_client.param_serialize(
            method='GET',
            resource_path='/challenges/undisbursed',
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth
        )


