# coding: utf-8

"""
    API

    Audius V1 API

    The version of the OpenAPI document: 1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from pyaudius.models.comment_mention import CommentMention
from typing import Optional, Set
from typing_extensions import Self

class ReplyComment(BaseModel):
    """
    ReplyComment
    """ # noqa: E501
    id: StrictStr
    user_id: StrictStr
    message: StrictStr
    mentions: Optional[List[CommentMention]] = None
    track_timestamp_s: Optional[StrictInt] = None
    react_count: StrictInt
    is_edited: StrictBool
    is_current_user_reacted: Optional[StrictBool] = None
    is_artist_reacted: Optional[StrictBool] = None
    created_at: StrictStr
    updated_at: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["id", "user_id", "message", "mentions", "track_timestamp_s", "react_count", "is_edited", "is_current_user_reacted", "is_artist_reacted", "created_at", "updated_at"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ReplyComment from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in mentions (list)
        _items = []
        if self.mentions:
            for _item_mentions in self.mentions:
                if _item_mentions:
                    _items.append(_item_mentions.to_dict())
            _dict['mentions'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ReplyComment from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "user_id": obj.get("user_id"),
            "message": obj.get("message"),
            "mentions": [CommentMention.from_dict(_item) for _item in obj["mentions"]] if obj.get("mentions") is not None else None,
            "track_timestamp_s": obj.get("track_timestamp_s"),
            "react_count": obj.get("react_count"),
            "is_edited": obj.get("is_edited"),
            "is_current_user_reacted": obj.get("is_current_user_reacted"),
            "is_artist_reacted": obj.get("is_artist_reacted"),
            "created_at": obj.get("created_at"),
            "updated_at": obj.get("updated_at")
        })
        return _obj


